import { world, ItemStack, ItemTypes } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { age1_quests, age1desc_en, splitquests_en, splitquestsdesc_en, age1_itself, age2_itself, questbooktitle, select_age, change_language, claim_quest, in_progress, claim_rewards, finished, locked, rewards_itself, rewards_en, splitquestsreward_en, back, age3_itself, stillinprogress, age2_quests, age2desc_en } from "./languages.js"
import { age1_chs, age1_itself_chs, age2_itself_chs, questbooktitle_chs, select_age_chs, change_language_chs, age1desc_chs, splitquests_chs, splitquestsdesc_chs, back_itself_chs, claim_quest_chs, in_progress_chs, claim_rewards_chs, finished_chs, locked_chs, rewards_itself_chs, rewards_chs, splitquestsreward_chs, age3_itself_chs, stillinprogress_chs, age2_quests_chs, age2desc_chs } from "./languages_ch_s.js"
import { age1_jp, age1_itself_jp, age2_itself_jp, questbooktitle_jp, select_age_jp, change_language_jp, age1desc_jp, splitquests_jp, splitquestsdesc_jp, claim_quest_jp, in_progress_jp, claim_rewards_jp, finished_jp, locked_jp, rewards_itself_jp, rewards_jp, back_jp, splitquestsreward_jp, age3_itself_jp, stillinprogress_jp, age2_quests_jp, age2desc_jp } from "./languages_jp.js"
import { age1_cht, age1_itself_cht, age2_itself_cht, questbooktitle_cht, select_age_cht, change_language_cht, age1desc_cht, splitquests_cht, splitquestsdesc_cht, back_itself_cht, claim_quest_cht, in_progress_cht, claim_rewards_cht, finished_cht, locked_cht, rewards_itself_cht, rewards_cht, splitquestsreward_cht, age3_itself_cht, stillinprogress_cht, age2_quests_cht, age2desc_cht } from "./languages_ch_t.js"

const age1image = ["textures/items/redpetal", "textures/blocks/_trees/bum_lemon_sapling", "textures/items/makeshiftaxe", "textures/blocks/crafting_table_side", "textures/items/flint", "textures/items/dried leaf", "textures/items/torchflower_seeds", "textures/items/wooden_shavings", "textures/items/makeshiftsieve", "textures/items/flint", "textures/items/paper", "textures/items/fluidbladder", "textures/items/leather", "textures/items/parts/stone/stone_blueprint", "textures/items/diamond_shard", "textures/items/wood_pickaxe", "textures/items/pebble", "textures/blocks/furnace_front_on", "textures/items/obsidianpestle", "textures/items/flint_and_steel", "textures/items/brick", "textures/items/clay_ball", "textures/items/bum_mug", "textures/items/brewer_pottery_sherd", "textures/items/burn_pottery_sherd", "textures/items/dye_powder_white_new", "textures/items/plantfiber", "textures/items/bone"]
const age2image = ["textures/items/brush", "textures/items/pamobile/mb_mossy_bony_helmet", "textures/items/pamobile/mb_mossy_bone", "textures/items/quartz", "textures/items/spider_eye_fermented", "textures/items/pamobile/mb_gloomy_ender_pearl", "textures/items/pamobile/mb_mossy_bony_pickaxe", "textures/blocks/copper_ore", "textures/items/woodupg", "textures/items/bed_white", "textures/ui/recipe_book_icon", "textures/items/woodgear", "textures/items/obsidianpestle", "textures/items/ash", "textures/items/honey_bottle", "textures/items/runeofunbreaking", "textures/items/nethersummon", "textures/items/warpedbark", "textures/items/parts/copper/copper_blueprint", "textures/items/cursedblazee", "textures/items/flame", "textures/blocks/ashenbrick1", "textures/blocks/ashenmeltertop2", "textures/blocks/forgefronton2", "textures/items/copper_ingot", "textures/items/smeltableprimalbronzeblend", "textures/items/bronze_pickaxe", "textures/items/smeltableiron", "textures/items/iron_ingot"]

const splitquestsimage = ["textures/items/campfireitem", "textures/items/charcoal", "textures/items/apple_charcoal", "textures/blocks/ladder", "textures/items/cattail", "textures/items/kelp", "textures/items/stone_hoe", "textures/items/wheat", "textures/items/thatch", "textures/items/flint", "textures/items/flintscraper", "textures/items/flintaxe", "textures/items/reeds", "textures/items/paperpulp", "textures/items/book_portfolio", "textures/items/lantern", "textures/items/fluidbladder", "textures/items/fullfluidbladder", "textures/skins/scraped", "textures/skins/tanned", "textures/items/leather", "textures/items/wood_sword", "textures/items/dryingrackupgrade", "textures/bp/backpack", "textures/blocks/stone_andesite", "textures/blocks/deepslate/cobbled_deepslate", "textures/blocks/tuff", "textures/items/magma_cream", "textures/items/pestle", "textures/items/pinksalt", "textures/items/dye_powder_purple", "textures/items/wheat", "textures/items/brick", "textures/items/rope", "textures/items/woodgear", "textures/items/bum_coffee_brew", "textures/items/amethyst_shard", "textures/items/porcleinclay", "textures/items/porclein",
    "textures/blocks/mb_glowing_skeleton_chiseled_gloomy_stone", "textures/items/mossclump", "textures/items/mossyscraper", "textures/blocks/qcactiveempty", "textures/blocks/altarside", "textures/blocks/pedestal_side", "textures/blocks/moss_block", "textures/blocks/mushroom_brown", "textures/blocks/coal_ore", "textures/items/raw_copper", "textures/items/raw_tin", "textures/items/bed_white", "textures/items/shloud", "textures/items/tinalloy", "textures/ui/recipe_book_icon", "textures/items/twine", "textures/items/ash", "textures/blocks/dust", "textures/items/honey_bottle", "textures/blocks/honeycomb", "textures/items/sets/copper/copper_mace", "textures/items/sets/tin/tin_lance", "textures/items/sets/all_ranged/wood_chakram", "textures/items/copper_ingot", "textures/items/tin_ingot", "textures/items/raw_iron", "textures/items/iron_ingot"]


const languageselect = ["English", "Japanese (日本語)", "Chinese Simplified (简体中文)", "Chinese Traditional (繁体中文)"]
const header = [age1_itself, age1_itself_jp, age1_itself_chs, age1_itself_cht]
const header2 = [age2_itself, age2_itself_jp, age2_itself_chs, age2_itself_cht]
const header3 = [age3_itself, age3_itself_jp, age3_itself_chs, age3_itself_cht]
const questbooktitlelang = [questbooktitle, questbooktitle_jp, questbooktitle_chs, questbooktitle_cht]
const select_agelang = [select_age, select_age_jp, select_age_chs, select_age_cht]
const change_languagelang = [change_language, change_language_jp, change_language_chs, change_language_cht]
const claim_questlang = [claim_quest, claim_quest_jp, claim_quest_chs, claim_quest_cht]
const in_progresslang = [in_progress, in_progress_jp, in_progress_chs, in_progress_cht]
const claim_rewardlang = [claim_rewards, claim_rewards_jp, claim_rewards_chs, claim_rewards_cht]
const finishedlang = [finished, finished_jp, finished_chs, finished_cht]
const lockedlang = [locked, locked_jp, locked_chs, locked_cht]
const rewards_itselflang = [rewards_itself, rewards_itself_jp, rewards_itself_chs, rewards_itself_cht]
const back_itselflang = [back, back_jp, back_itself_chs, back_itself_cht]
const still_in_progress = [stillinprogress, stillinprogress_jp, stillinprogress_chs, stillinprogress_cht]

var age1 = age1_quests
var age1desc = age1desc_en
var rewards = rewards_en
var splitquests = splitquests_en
var age2 = age2_quests
var age2desc = age2desc_en
var splitquestsdesc = splitquestsdesc_en
var splitquestsreward = splitquestsreward_en

var questlist = age1
var questlistdesc = age1desc



world.afterEvents.itemUse.subscribe((eventData) => {
    const itemTypeId = eventData.itemStack.typeId
    if (itemTypeId == "pcr:questbook") {
        questmenu(eventData.source)
    }
})

function questmenu(player) {
    const lang = world.scoreboard.getObjective('language').getScore(player)
    const quests = world.scoreboard.getObjective('quests').getScore(player)
    const form = new ActionFormData()
    form.title(questbooktitlelang[lang])
    form.body(select_agelang[lang])
    form.button(header[lang], "textures/items/redbook")
    form.button(header2[lang], "textures/items/orangebook")
    form.button(header3[lang], "textures/items/yellowbook")
    form.button(change_languagelang[lang], "textures/items/language")
    form.show(player).then((response) => {
        switch (response?.selection) {
            case 0:
                showquestlist(player, 1)
                break
            case 1:
                if (quests >= 45) {
                    showquestlist(player, 2)
                }
                else {
                    player.runCommandAsync('say ' + lockedlang[lang])
                }
                break
            case 2:
                //quests >= 98
                player.runCommandAsync('say ' + still_in_progress[lang])
                break
            case 3:
                languagechoice(player)
                break
        }
    })
}
//Language Selection
function languagechoice(player) {
    const form = new ActionFormData()
    const language = world.scoreboard.getObjective('language').getScore(player)
    form.title(change_languagelang[language])
    for (let lang in languageselect) {
        form.button(languageselect[lang])
    }
    form.show(player).then((response) => {
        switch (response?.selection) {
            case 0:
                player.runCommandAsync('scoreboard players set @s language 0')
                break
            case 1:
                player.runCommandAsync('scoreboard players set @s language 1')
                break
            case 2:
                player.runCommandAsync('scoreboard players set @s language 2')
                break
            case 3:
                player.runCommandAsync('scoreboard players set @s language 3')
                break
        }
    })
}


function showquestlist(player, age) {

    const quests = world.scoreboard.getObjective('quests').getScore(player)
    const lang = world.scoreboard.getObjective('language').getScore(player)
    const questfinished = world.scoreboard.getObjective('questfin').getScore(player)

    const form = new ActionFormData()
    setdescriptions(lang)
    if (age == 1) {
        form.title(header[lang])
        const ageheader = age1
        for (let quests in age1) {
            form.button(age1[quests], age1image[quests])
        }
        form.show(player).then((response) => {
            switch (response?.selection) {
                case 0:
                    const questnum = 0
                    const form = new ActionFormData()
                    form.title(ageheader[questnum])
                    form.body(age1desc[questnum] + rewards_itselflang[lang] + rewards[questnum])
                    if (quests == 0) {
                        form.button(claim_questlang[lang])
                        form.show(player).then((response) => {
                            if (response?.selection === 0) {
                                player.runCommandAsync('scoreboard players add @s quests 1')
                                player.runCommandAsync('give @s pcr:offeringbox')
                            }
                        })
                    }
                    else if (quests == 1) {
                        form.button(in_progresslang[lang])
                        form.show(player)
                    }
                    else if (quests == 2) {
                        form.button(claim_rewardlang[lang])
                        form.show(player).then((response) => {
                            if (response?.selection === 0) {
                                player.runCommandAsync('scoreboard players add @s quests 1')
                                givecom("bumble:lemon", 1, player)
                                player.runCommandAsync('scoreboard players add @s questfin 1')
                            }
                        })
                    }
                    else if (quests > 2) {
                        form.button(finishedlang[lang])
                        form.show(player)
                    }
                    break
                case 1:
                    questlabel(1, 1, 1, player, "bumble:grapes", 1)
                    break
                case 2:
                    questlabel(2, 2, 2, player, "rns:pebble", 1)
                    break
                case 3:
                    questlabel(3, 3, 3, player, "air", 1)
                    break
                case 4:
                    if (questfinished >= 4) {
                        showsplitquest(0, 2, player, 1, 4, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 5:
                    if (questfinished >= 4) {
                        showsplitquest(3, 5, player, 2, 5, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 6:
                    if (questfinished >= 4) {
                        showsplitquest(6, 8, player, 3, 6, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 7:
                    questlabel(7, 4, 4, player, "air", 1)
                    break
                case 8:
                    questlabel(8, 5, 5, player, "dropper", 1)
                    break
                case 9:
                    if (questfinished >= 4) {
                        showsplitquest(9, 11, player, 4, 9, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 10:
                    if (questfinished >= 4) {
                        showsplitquest(12, 15, player, 5, 10, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 11:
                    if (questfinished >= 4) {
                        showsplitquest(16, 17, player, 6, 11, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 12:
                    if (questfinished >= 4) {
                        showsplitquest(18, 20, player, 7, 12, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 13:
                    questlabel(13, 6, 6, player, "rns:roastedstuffedbeetroot", 1)
                    break
                case 14:
                    if (questfinished >= 4) {
                        showsplitquest(21, 23, player, 8, 14, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 15:
                    questlabel(15, 7, 7, player, "air")
                    break
                case 16:
                    if (questfinished >= 4) {
                        showsplitquest(24, 27, player, 9, 16, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 17:
                    questlabel(17, 8, 8, player, "coal", 1)
                    break
                case 18:
                    if (questfinished >= 4) {
                        showsplitquest(28, 30, player, 10, 18, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 19:
                    questlabel(19, 9, 9, player, "hax:obsidian_dagger", 1)
                    break
                case 20:
                    if (questfinished >= 4) {
                        showsplitquest(31, 32, player, 11, 20, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 21:
                    if (questfinished >= 4) {
                        showsplitquest(33, 35, player, 12, 21, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 22:
                    questlabel(22, 10, 10, player, "bumble:coffee_beans", 1)
                    break
                case 23:
                    questlabel(23, 11, 11, player, "light_blue_glazed_terracotta", 1)
                    break
                case 24:
                    questlabel(24, 12, 12, player, "red_glazed_terracotta", 1)
                    break
                case 25:
                    if (questfinished >= 4) {
                        showsplitquest(36, 38, player, 13, 25, 1)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 26:
                    questlabel(26, 13, 13, player, "rns:rocksaltlamp", 1)
                    break
                case 27:
                    questlabel(27, 14, 14, player, "cake", 1)
                    break
            }
        })
    }
    if (age == 2) {
        form.title(header2[lang])
        for (let quests in age2) {
            form.button(age2[quests], age2image[quests])
        }
        form.show(player).then((response) => {
            switch (response?.selection) {
                case 0:
                    questlabel(1, 1, 15, player, "c8164:caked_on", 2)
                    break
                case 1:
                    if (questfinished >= 8) {
                        showsplitquest(39, 41, player, 14, 1, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 2:
                    questlabel(2, 2, 16, player, "minecraft:bone_block", 2)
                    break
                case 3:
                    if (questfinished >= 8) {
                        showsplitquest(42, 44, player, 15, 3, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 4:
                    questlabel(4, 3, 17, player, "air", 2)
                    break
                case 5:
                    if (questfinished >= 8) {
                        showsplitquest(45, 47, player, 16, 5, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 6:
                    questlabel(6, 4, 18, player, "mb:mossy_skeleton_2", 2)
                    break
                case 7:
                    if (questfinished >= 8) {
                        showsplitquest(48, 49, player, 17, 7, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 8:
                    questlabel(8, 5, 19, player, "bumble:orange_sapling_item", 2)
                    break
                case 9:
                    if (questfinished >= 8) {
                        showsplitquest(50, 51, player, 18, 9, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 10:
                    if (questfinished >= 8) {
                        showsplitquest(52, 53, player, 19, 10, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 11:
                    questlabel(11, 6, 20, player, "hax:raw_tin", 2)
                    break
                case 12:
                    questlabel(12, 7, 21, player, "minecraft:hay_block", 2)
                    break
                case 13:
                    if (questfinished >= 8) {
                        showsplitquest(54, 56, player, 20, 13, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 14:
                    if (questfinished >= 8) {
                        showsplitquest(57, 58, player, 21, 14, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 15:
                    questlabel(15, 8, 22, player, "c8164:hat_witch", 2)
                    break
                case 16:
                    questlabel(16, 9, 23, player, "bumble:chili", 2)
                    break
                case 17:
                    questlabel(17, 10, 24, player, "air", 2)
                    break
                case 18:
                    if (questfinished >= 8) {
                        showsplitquest(59, 61, player, 22, 18, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 19:
                    questlabel(19, 11, 25, player, "minecraft:golden_apple", 2)
                    break
                case 20:
                    questlabel(20, 12, 26, player, "minecraft:experience_bottle", 2)
                    break
                case 21:
                    questlabel(21, 13, 27, player, "minecraft:clay", 2)
                    break
                case 22:
                    questlabel(22, 14, 28, player, "air", 2)
                    break
                case 23:
                    questlabel(23, 15, 29, player, "c8164:mask_furnace", 2)
                    break
                case 24:
                    if (questfinished >= 8) {
                        showsplitquest(62, 63, player, 23, 24, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 25:
                    questlabel(25, 16, 30, player, "hax:bronze_spadehead", 2)
                    break
                case 26:
                    questlabel(26, 17, 31, player, "minecraft:cooked_porkchop", 2)
                    break
                case 27:
                    if (questfinished >= 8) {
                        showsplitquest(64, 65, player, 24, 27, 2)
                    }
                    else {
                        player.runCommandAsync('say ' + lockedlang[lang])
                    }
                    break
                case 28:
                    questlabel(28, 18, 32, player, "minecraft:goat_horn", 2)
                    break
            }
        })
    }
}

function setdescriptions(lang) {
    if (lang == 0) {
        age1 = age1_quests
        age1desc = age1desc_en
        rewards = rewards_en
        splitquests = splitquests_en
        splitquestsdesc = splitquestsdesc_en
        splitquestsreward = splitquestsreward_en
        age2 = age2_quests
        age2desc = age2desc_en
    }
    else if (lang == 1) {
        age1 = age1_jp
        age1desc = age1desc_jp
        rewards = rewards_jp
        splitquests = splitquests_jp
        splitquestsdesc = splitquestsdesc_jp
        splitquestsreward = splitquestsreward_jp
        age2 = age2_quests_jp
        age2desc = age2desc_jp
    }
    else if (lang == 2) {
        age1 = age1_chs
        age1desc = age1desc_chs
        rewards = rewards_chs
        splitquests = splitquests_chs
        splitquestsdesc = splitquestsdesc_chs
        splitquestsreward = splitquestsreward_chs
        age2 = age2_quests_chs
        age2desc = age2desc_chs
    }
    else if (lang == 3) {
        age1 = age1_cht
        age1desc = age1desc_cht
        rewards = rewards_cht
        splitquests = splitquests_cht
        splitquestsdesc = splitquestsdesc_cht
        splitquestsreward = splitquestsreward_cht
        age2 = age2_quests_cht
        age2desc = age2desc_cht
    }

}

function whichage(age) {
    if (age == 1) {
        questlist = age1
        questlistdesc = age1desc
    }
    if (age == 2) {
        questlist = age2
        questlistdesc = age2desc
    }
}

function questlabel(questnum, questdesc, amount, player, reward, age) {
    const lang = world.scoreboard.getObjective('language').getScore(player)
    const quests = world.scoreboard.getObjective('quests').getScore(player)
    const questfinished = world.scoreboard.getObjective('questfin').getScore(player)
    whichage(age)
    const form = new ActionFormData()
    setdescriptions(lang)
    form.title(questlist[questnum])
    form.body(questlistdesc[questdesc] + rewards_itselflang[lang] + rewards[amount])
    if (quests == amount * 3 && questfinished > 0) {
        form.button(claim_questlang[lang])
    }
    else if (quests == amount * 3 + 1 && questfinished > 0) {
        form.button(in_progresslang[lang])
    }
    else if (quests == amount * 3 + 2 && questfinished > 0) {
        form.button(claim_rewardlang[lang])
    }
    else if (quests > 3 * amount) {
        form.button(finishedlang[lang])
    }
    else {
        form.button(lockedlang[lang])
    }
    form.button(back_itselflang[lang])
    form.show(player).then((response) => {
        if (quests == amount * 3 && questfinished > 0 && response?.selection === 0) {
            player.runCommandAsync('scoreboard players add @s quests 1')
            showquestlist(player, age)
        }
        if (quests == amount * 3 + 2 && questfinished > 0 && response?.selection === 0) {
            player.runCommandAsync('scoreboard players add @s quests 1')
            givecom(reward, 1, player)
            player.runCommandAsync('scoreboard players add @s questfin 1')
        }
        else if (response?.selection === 1) {
            showquestlist(player, age)
        }
    })
}

function givecom(item, amount, player) {
    player.runCommandAsync('give @s ' + item + " " + amount)
    player.runCommandAsync('summon xp_orb')
}

//Amount should stack up with the same quest set lines!!

function showsplitquest(start, end, player, questset, settitle, age) {
    const lang = world.scoreboard.getObjective('language').getScore(player)
    const form = new ActionFormData()
    whichage(age)
    setdescriptions(lang)
    form.title(questlist[settitle])
    let backamount = 0
    for (let i = start; i < end + 1; i++) {
        form.button(splitquests[i], splitquestsimage[i])
        backamount += 1
    }
    form.button(back_itselflang[lang])
    form.show(player).then((response) => {
        if (response?.selection === backamount) {
            showquestlist(player, age)
        }
        if (questset === 1) {
            if (response?.selection === 0) {
                splitquest(1, 1, player, "log", 12, 1, 1, 0, 2, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(2, 2, player, "fuelov:mini_charcoal", 12, 1, 1, 0, 2, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(3, 3, player, "apple", 12, 1, 1, 0, 2, settitle, 1)
            }
        }
        else if (questset === 2) {
            if (response?.selection === 0) {
                splitquest(4, 1, player, "air", 12, 2, 2, 3, 5, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(5, 2, player, "rns:applechip", 12, 2, 2, 3, 5, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(6, 3, player, "c8164:hat_sun", 12, 2, 2, 3, 5, settitle, 1)
            }
        }
        else if (questset === 3) {
            if (response?.selection === 0) {
                splitquest(7, 1, player, "air", 12, 3, 3, 6, 8, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(8, 2, player, "air", 12, 3, 3, 6, 8, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(9, 3, player, "air", 12, 3, 3, 6, 8, settitle, 1)
            }
        }
        else if (questset === 4) {
            if (response?.selection === 0) {
                splitquest(10, 4, player, "flint", 18, 1, 4, 9, 11, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(11, 5, player, "air", 18, 1, 4, 9, 11, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(12, 6, player, "hax:slime_berserker_helmet", 18, 1, 4, 9, 11, settitle, 1)
            }
        }
        else if (questset === 5) {
            if (response?.selection === 0) {
                splitquest(13, 4, player, "hax:wood_spear", 18, 2, 5, 12, 15, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(14, 5, player, "air", 18, 2, 5, 12, 15, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(15, 6, player, "add:washed_hide", 18, 2, 5, 12, 15, settitle, 1)
            }
            else if (response?.selection === 3) {
                splitquest(16, 7, player, "hax:slime_boots", 18, 2, 5, 12, 15, settitle, 1)
            }
        }
        else if (questset === 6) {
            if (response?.selection === 0) {
                splitquest(17, 4, player, "air", 18, 3, 6, 16, 17, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(18, 5, player, "bumble:potted_cattail", 18, 3, 6, 16, 17, settitle, 1)
            }
        }
        else if (questset === 7) {
            if (response?.selection === 0) {
                splitquest(19, 7, player, "bumble:chili", 18, 1, 7, 18, 20, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(20, 8, player, "btb:makeshiftsieve", 18, 1, 7, 18, 20, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(21, 9, player, "leather", 18, 1, 7, 18, 20, settitle, 1)
            }
        }
        else if (questset === 8) {
            if (response?.selection === 0) {
                splitquest(22, 8, player, "air", 21, 2, 8, 21, 23, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(23, 9, player, "rns:pinkrocksalt", 21, 2, 8, 21, 23, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(24, 10, player, "c8164:backpack_travelling", 21, 2, 8, 21, 23, settitle, 1)
            }
        }
        else if (questset === 9) {
            if (response?.selection === 0) {
                splitquest(25, 6, player, "air", 24, 3, 9, 24, 27, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(26, 7, player, "air", 24, 3, 9, 24, 27, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(27, 8, player, "torch", 24, 3, 9, 24, 27, settitle, 1)
            }
            else if (response?.selection === 3) {
                splitquest(28, 9, player, "torch", 24, 3, 9, 24, 27, settitle, 1)
            }
        }
        else if (questset === 10) {
            if (response?.selection === 0) {
                splitquest(29, 10, player, "sweet_berries", 27, 1, 10, 28, 30, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(30, 11, player, "glow_berries", 27, 1, 10, 28, 30, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(31, 12, player, "rns:nimberry", 27, 1, 10, 28, 30, settitle, 1)
            }
        }
        else if (questset === 11) {
            if (response?.selection === 0) {
                splitquest(32, 11, player, "air", 30, 2, 11, 31, 32, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(33, 12, player, "bumble:popcorn", 30, 2, 11, 31, 32, settitle, 1)
            }
        }
        else if (questset === 12) {
            if (response?.selection === 0) {
                splitquest(34, 10, player, "sev:twine", 30, 3, 12, 33, 35, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(35, 11, player, "sev:twine", 30, 3, 12, 33, 35, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(36, 12, player, "clay", 30, 3, 12, 33, 35, settitle, 1)
            }
        }
        else if (questset === 13) {
            if (response?.selection === 0) {
                splitquest(37, 13, player, "budding_amethyst", 39, 1, 13, 36, 38, settitle, 1)
            }
            else if (response?.selection === 1) {
                splitquest(38, 14, player, "bone", 39, 1, 13, 36, 38, settitle, 1)
            }
            else if (response?.selection === 2) {
                splitquest(39, 15, player, "calcite", 39, 1, 13, 36, 38, settitle, 1)
            }
        }
        else if (questset === 14) {
            if (response?.selection === 0) {
                splitquest(40, 13, player, "mb:gloomy_vase", 45, 2, 14, 39, 41, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(41, 14, player, "small_dripleaf_block", 45, 2, 14, 39, 41, settitle, 2)
            }
            else if (response?.selection === 2) {
                splitquest(42, 15, player, "rns:flintscraper", 45, 2, 14, 39, 41, settitle, 2)
            }
        }
        else if (questset === 15) {
            if (response?.selection === 0) {
                splitquest(43, 13, player, "pcr:claycooker", 48, 3, 15, 42, 44, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(44, 14, player, "pumpkin_pie", 48, 3, 15, 42, 44, settitle, 2)
            }
            else if (response?.selection === 2) {
                splitquest(45, 15, player, "quartz", 48, 3, 15, 42, 44, settitle, 2)
            }
        }
        else if (questset === 16) {
            if (response?.selection === 0) {
                splitquest(46, 16, player, "air", 51, 1, 16, 45, 47, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(47, 17, player, "air", 51, 1, 16, 45, 47, settitle, 2)
            }
            else if (response?.selection === 2) {
                splitquest(48, 18, player, "c8164:crown_flower", 51, 1, 16, 45, 47, settitle, 2)
            }
        }
        else if (questset === 17) {
            if (response?.selection === 0) {
                splitquest(49, 16, player, "bumble:sandwich", 54, 2, 17, 48, 49, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(50, 17, player, "bumble:sandwich", 54, 2, 17, 48, 49, settitle, 2)
            }
        }
        else if (questset === 18) {
            if (response?.selection === 0) {
                splitquest(51, 16, player, "c8164:blindfold1", 57, 3, 18, 50, 51, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(52, 17, player, "minecraft:name_tag", 57, 3, 18, 50, 51, settitle, 2)
            }
        }
        else if (questset === 19) {
            if (response?.selection === 0) {
                splitquest(53, 19, player, "hax:tin_spartan_helmet", 57, 1, 19, 52, 53, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(54, 20, player, "air", 57, 1, 19, 52, 53, settitle, 2)
            }
        }
        else if (questset === 20) {
            if (response?.selection === 0) {
                splitquest(55, 18, player, "air", 60, 2, 20, 54, 56, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(56, 19, player, "fuelov:beetroot_charcoal", 60, 2, 20, 54, 56, settitle, 2)
            }
            else if (response?.selection === 2) {
                splitquest(57, 20, player, "minecraft:potion", 60, 2, 20, 54, 56, settitle, 2)
            }
        }
        else if (questset === 21) {
            if (response?.selection === 0) {
                splitquest(58, 18, player, "minecraft:glass_bottle", 60, 3, 21, 57, 58, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(59, 19, player, "minecraft:honeycomb_block", 60, 3, 21, 57, 58, settitle, 2)
            }
        }
        else if (questset === 22) {
            if (response?.selection === 0) {
                splitquest(60, 21, player, "minecraft:raw_copper", 66, 1, 22, 59, 61, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(61, 22, player, "hax:raw_tin", 66, 1, 22, 59, 61, settitle, 2)
            }
            else if (response?.selection === 2) {
                splitquest(62, 23, player, "minecraft:target", 66, 1, 22, 59, 61, settitle, 2)
            }
        }
        else if (questset === 23) {
            if (response?.selection === 0) {
                splitquest(63, 21, player, "air", 75, 2, 23, 62, 63, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(64, 22, player, "air", 75, 2, 23, 62, 63, settitle, 2)
            }
        }
        else if (questset === 24) {
            if (response?.selection === 0) {
                splitquest(65, 20, player, "air", 78, 3, 24, 64, 65, settitle, 2)
            }
            else if (response?.selection === 1) {
                splitquest(66, 21, player, "air", 78, 3, 24, 64, 65, settitle, 2)
            }
        }
    })
}

function splitquest(questnum, amount, player, reward, requirement, questset, returnquestset, start, end, settitle, age) {
    const lang = world.scoreboard.getObjective('language').getScore(player)
    const quests = world.scoreboard.getObjective('quests').getScore(player)
    const quest1 = world.scoreboard.getObjective('quest1').getScore(player)
    const quest2 = world.scoreboard.getObjective('quest2').getScore(player)
    const quest3 = world.scoreboard.getObjective('quest3').getScore(player)


    const form = new ActionFormData()
    setdescriptions(lang)
    form.title(splitquests[questnum - 1])
    form.body(splitquestsdesc[questnum - 1] + rewards_itselflang[lang] + splitquestsreward[questnum - 1])
    if (questset === 1) {
        if (quest1 == amount * 3 - 3 && quests >= requirement) {
            form.button(claim_questlang[lang])
        }
        else if (quest1 == amount * 3 - 2 && quests >= requirement) {
            form.button(in_progresslang[lang])
        }
        else if (quest1 == amount * 3 - 1 && quests >= requirement) {
            form.button(claim_rewardlang[lang])
        }
        else if (quest1 > 3 * amount - 3) {
            form.button(finishedlang[lang])
        }
        else {
            form.button(lockedlang[lang])
        }
        form.button(back_itselflang[lang])
        form.show(player).then((response) => {
            if (quest1 == amount * 3 - 3 && quests >= requirement && response?.selection === 0) {
                player.runCommandAsync('scoreboard players add @s quest1 1')
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
            if (quest1 == amount * 3 - 1 && quests >= requirement && response?.selection === 0) {
                player.runCommandAsync('scoreboard players add @s quest1 1')
                givecom(reward, 1, player)
                player.runCommandAsync('scoreboard players add @s questfin 1')
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
            else if (response?.selection === 1) {
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
        })
    }
    else if (questset === 2) {
        if (quest2 == amount * 3 - 3 && quests >= requirement) {
            form.button(claim_questlang[lang])
        }
        else if (quest2 == amount * 3 - 2 && quests >= requirement) {
            form.button(in_progresslang[lang])
        }
        else if (quest2 == amount * 3 - 1 && quests >= requirement) {
            form.button(claim_rewardlang[lang])
        }
        else if (quest2 > 3 * amount - 3) {
            form.button(finishedlang[lang])
        }
        else {
            form.button(lockedlang[lang])
        }
        form.button(back_itselflang[lang])
        form.show(player).then((response) => {
            if (quest2 == amount * 3 - 3 && quests >= requirement && response?.selection === 0) {
                player.runCommandAsync('scoreboard players add @s quest2 1')
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
            if (quest2 == amount * 3 - 1 && quests >= requirement && response?.selection === 0) {
                player.runCommandAsync('scoreboard players add @s quest2 1')
                givecom(reward, 1, player)
                player.runCommandAsync('scoreboard players add @s questfin 1')
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
            else if (response?.selection === 1) {
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
        })
    }
    else if (questset === 3) {
        if (quest3 == amount * 3 - 3 && quests >= requirement) {
            form.button(claim_questlang[lang])
        }
        else if (quest3 == amount * 3 - 2 && quests >= requirement) {
            form.button(in_progresslang[lang])
        }
        else if (quest3 == amount * 3 - 1 && quests >= requirement) {
            form.button(claim_rewardlang[lang])
        }
        else if (quest3 > 3 * amount - 3) {
            form.button(finishedlang[lang])
        }
        else {
            form.button(lockedlang[lang])
        }
        form.button(back_itselflang[lang])
        form.show(player).then((response) => {
            if (quest3 == amount * 3 - 3 && quests >= requirement && response?.selection === 0) {
                player.runCommandAsync('scoreboard players add @s quest3 1')
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
            if (quest3 == amount * 3 - 1 && quests >= requirement && response?.selection === 0) {
                player.runCommandAsync('scoreboard players add @s quest3 1')
                givecom(reward, 1, player)
                player.runCommandAsync('scoreboard players add @s questfin 1')
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
            else if (response?.selection === 1) {
                showsplitquest(start, end, player, returnquestset, settitle, age)
            }
        })
    }
}